public class Lab3 {

  public static void main(String[] args) {

    // Set up some arrays of strings, A and B, 
    // to use in the tests below
    String[] A = {"Amy","Bob","Eve","Jan","Ken","Ned","Peg","Sam","Ted","Vic"};
    String[] B = {"Abe","Ben","Cal","Gil","Jim","Meg","Pam","Ray","Sue","Tom","Wil"};
    int i;        // i is an index variable used to test the binary searching methods
    int result;                    // test results are stored in the variable, result

    // Conduct tests and print test results

    // Print the contents of the ordered string array A:
    System.out.println("The contents of the ordered string array A are:");
    for (i = 0; i < A.length; i++) {
      System.out.print(A[i]+" ");
    }
    System.out.println();
    for (i = 0; i < A.length; i++) {
      System.out.print(" " + i +"  ");
    }
    System.out.println();
    System.out.println();

    // Test successful searching by searching for each of the keys in array A
    // at first using iterative binary search
    System.out.println("First, test successful binary searching");
    System.out.println("using iterative binary search:");
    for (i = 0; i < A.length; i++) {
      result = iterativeBinarySearch(A[i],A,0,A.length-1);
      System.out.println("Key \""+A[i]+"\" found at position A["  + result + "]");
    }
    System.out.println();
    // Test successful searching by searching for each of the keys in array A
    // using recursive binary search
    System.out.println("Next, test successful binary searching");
    System.out.println("using recursive binary search:");
    for (i = 0; i < A.length; i++) {
      result = recursiveBinarySearch(A[i],A,0,A.length-1);
      System.out.println("Key \""+A[i]+"\" found at position A["  + result + "]");
    }
    System.out.println();
    System.out.println();

    // Print the ordered string array B containing keys to use
    // in unsuccessful binary searching:
    System.out.println("The search keys in array B will be used");
    System.out.println("in unsuccessful binary searching.");
    System.out.println("The contents of the ordered string array B are:");
    for (i = 0; i < B.length; i++) {
      System.out.print(B[i]+" ");
    }
    System.out.println();
    for (i = 0; i < B.length; i++) {
      System.out.print(" " + i +"  ");
    }
    System.out.println();
    System.out.println();

    // Test unsuccessful searching by searching array A for each of the keys
    //  in array B at first using iterative binary search
    System.out.println("Then, test unsuccessful binary searching using");
    System.out.println("iterative binary search:");
    for (i = 0; i < B.length; i++) {
      result = iterativeBinarySearch(B[i],A,0,A.length-1);
      System.out.println("Key \""  + B[i]
			 + "\" not found in array A. Search result = "
			 + result);
    }
    System.out.println();

    // Test unsuccessful searching by searching array A 
    // for each of the keys in array B
    // using recursive binary search
    System.out.println("Next, test unsuccessful binary searching using");
    System.out.println("recursive binary search:");
    for (i = 0; i < B.length; i++) {
      result = recursiveBinarySearch(B[i],A,0,A.length-1);
      System.out.println("Key \"" + B[i] + 
			 "\" not found in array A. Search result = " + result);
    }
    System.out.println();
    
  }   // end main

  /*----------------------------------------------------------------------------*/
  /** Program C.41 Iterative Binary Search -- modified slightly                 */

  static int iterativeBinarySearch(String K, String[] A, int L, int R) {  
    // to find the position of the string search
    // key K in the ordered String subarray A[L,R]

    int midpoint;                        // midpoint == midpoint of search interval
    int comparisonResult;              // the integer result of a String comparison
  
    // while the interval L:R is non-empty test K against the middle key

    while ( L <= R )  {                          // while the interval is non-empty
      midpoint = (L+R) / 2;                     // compute midpoint of interval L:R
      comparisonResult = K.compareTo(A[midpoint]);
      if (comparisonResult == 0){            // if key K was found at the midpoint,
	// return from the function
	return midpoint;                             // with midpoint as the result
      } else if (comparisonResult > 0) {               // otherwise, if K is to the
	// right of the midpoint, search
	L = midpoint + 1;                      // next in the interval midpoint+1:R
      } else {              // whereas if K is to the  left of the midpoint, search
	R = midpoint - 1;                      // next in the interval L:midpoint-1
      }
    }
      
    // if the search interval became empty, key K was not found
    return - 1;                                     // -1 means K was not in A[L,R]
  
  } // end iterativeBinarySearch


  /*----------------------------------------------------------------------------*/
  /* Refine the Program Strategy below into recursive binary search method      */

  /** Program Strategy for Recursive Binary Search for a String Key, K          */

  static int recursiveBinarySearch(String K, String[] A, int L, int R) {  
    // to find the position of the string search
    // key K in the ordered String subarray A[L,R]
  
    (declare an integer variable, midpoint, to hold the middle position)
    (  of the search interval);

    (declare an integer variable, comparisonResult, to hold the)
    (  integer result of a string comparison)


    (compute the midpoint of the interval L:R)
  
    if  (the search interval is empty) {
      (return -1 to signal that K is not in A[L:R])
    } else {
      (compare the String search key K with the String at A[midpoint])
      (   using the three way String comparison method of the form)
      (   S1.compareTo(S2), and save the integer result in the)
      (   variable, comparisonResult);
      if (the strings were equal) {
        (return the value of the midpoint)     // the search was successful
      } else if (search key K was alphabetically greater than A[midpoint]) {
        (return the result of searching recursively)
        (    for K in A[midpoint+1:R]);
      } else {
        (return the result of searching recursively)
        (    for K in A[L:midpoint-1]);
      }
    }

  }   // end recursiveBinarySearch

  /*----------------------------------------------------------------------------*/

}       // end Lab3
