import java.util.Vector;

public class Lab5 {

  final static int MAX_COUNT = 26;

  static HuffmanTreeNode[] nodeArray = new HuffmanTreeNode[MAX_COUNT];

  public static void main(String[] args) {

    initNodeArray();
    constructHuffmanTree();
    assignHuffmanCodes(nodeArray[0],"");
    printHuffmanCodes(nodeArray[0]); 

  }     // end main

  static void initNodeArray(){
    int i; 
    String letters = "ETAONISRHLDCUPFMWYBGVKQXJZ"; 
    HuffmanTreeNode N;
    
    for (i = 0; i< MAX_COUNT; ++i) {
      N = new HuffmanTreeNode();
      N.letter = letters.charAt(i);
      N.LLink = null;
      N.RLink = null;
      nodeArray[i] = N;
    }
    
    // input letter frequencies from Table 8.48, followed by the letter
    // having that frequency
    
    nodeArray[ 0].frequency  = 1231;         // E    
    nodeArray[ 1].frequency  =  959;         // T 
    nodeArray[ 2].frequency  =  805;         // A 
    nodeArray[ 3].frequency  =  794;         // O 
    nodeArray[ 4].frequency  =  719;         // N 
    nodeArray[ 5].frequency  =  718;         // I 
    nodeArray[ 6].frequency  =  659;         // S 
    nodeArray[ 7].frequency  =  603;         // R 
    nodeArray[ 8].frequency  =  514;         // H 
    nodeArray[ 9].frequency  =  403;         // L 
    nodeArray[10].frequency  =  365;         // D 
    nodeArray[11].frequency  =  320;         // C 
    nodeArray[12].frequency  =  310;         // U 
    nodeArray[13].frequency  =  229;         // P  
    nodeArray[14].frequency  =  228;         // F  
    nodeArray[15].frequency  =  225;         // M 
    nodeArray[16].frequency  =  203;         // W 
    nodeArray[17].frequency  =  188;         // Y 
    nodeArray[18].frequency  =  162;         // B 
    nodeArray[19].frequency  =  161;         // G  
    nodeArray[20].frequency  =   93;         // V 
    nodeArray[21].frequency  =   52;         // K  
    nodeArray[22].frequency  =   20;         // Q  
    nodeArray[23].frequency  =   20;         // X 
    nodeArray[24].frequency  =   10;         // J  
    nodeArray[25].frequency  =    9;         // Z  
    
    // if the nodeArray is not sorted in descending order of frequencies, 
    // sort it here 

  }     //end initNodeArray
  
  /* -------------------------------------------------------------------------------- */
  /* refine the following Program Strategy into actual Java code */
  
  static void constructHuffmanTree() {
    
    int i, j; 
    HuffmanTreeNode N; 
    
    for (i = MAX_COUNT-1 downto 1 in steps of -1) {
      
      (Allocate a new HuffmanTreeNode and let N be a pointer to it)
        
      (Set node N's frequency to the sum of the frequencies of)
      (   the nodes in nodeArray[i] and nodeArray[i-1])

      (Then, let N's RLink point to the node in nodeArray[i], and)
      (   let N's LLink point to the node in nodeArray[i-1].)

      (Now, insert the new node N in proper order of its frequency )
      (    in nodeArray[0:i-2] by moving nodes with frequencies smaller )
      (    than N's frequency one space to the right and by putting N)
      (    into the hole opened up by shifting nodes with smaller  )
      (    frequencies one space to the right)
                
    } // end for
    
  } // end constructHuffmanTree
  
  /* --------------------------------------------------------------------- */
  
  static void assignHuffmanCodes(HuffmanTreeNode N, String codeToAssign) {
    
    HuffmanTreeNode L, R;                                                                                                                               // assume N is non-null
    N.code = codeToAssign;
    L = N.LLink;
    R = N.RLink;
    if (L != null) assignHuffmanCodes(L,codeToAssign.concat("0"));
    if (R != null) assignHuffmanCodes(R,codeToAssign.concat("1"));
    
  } //end assignHuffmanCodes
  
  /* ---------------------------------------------------------------------------------- */
  
  static void printHuffmanCodes(HuffmanTreeNode N){
    if (N != null) {
      if ((N.RLink == null) && (N.LLink == null)) {
        System.out.println(N.letter + " - " + N.code);
      }
      printHuffmanCodes(N.LLink);
      printHuffmanCodes(N.RLink);
    }
    
  }     // printHuffmanCodes
  
  /* ---------------------------------------------------------------------------------- */
  
}       // end Lab5

/* ---------------------------------------------------------------------------------- */

class HuffmanTreeNode {
  char            letter;
  int             frequency;
  String          code;
  HuffmanTreeNode LLink;
  HuffmanTreeNode RLink;
}

/* ---------------------------------------------------------------------------------- */
